include("IconSupport");
include("InstanceManager");
include("InfoTooltipInclude");

--g_InstanceManager = InstanceManager:new( "BInstance", "Base", Controls.ItemStack )

function OnShowListPointedStrike(iX, iY)
	print("OnShowListPointedStrike! start")
	local plot = Map.GetPlot(iX, iY);
	local city = plot:GetPlotCity();
	if(city ~= nil) then
		PointedStrikeUpdateList(city)
		--UIManager:QueuePopup( ContextPtr );
		ContextPtr:SetHide(false);
	else
		print("OnShowListPointedStrike! Error!")
	end
end

function PointedStrikeUpdateList(pTargetCity)
	print("PointedStrikeUpdateList! start")
	local pUnit = UI.GetHeadSelectedUnit();
	g_InstanceManager:ResetInstances();
	
	if (pUnit ~= nil and pTargetCity ~= nil) then
		--if (pUnit:canPointedStrikeAt(pTargetCity:GetX(), pTargetCity:GetY())) then
			--local BuildingEntry = g_InstanceManager:GetInstance();
			--BuildingEntry.Button:LocalizeAndSetText("TXT_KEY_POINTEDSTRIKE");
			--BuildingEntry.Button:RegisterCallback(Mouse.eLClick, function()
			--	OnSelected(unit, pTargetCity:GetX(), pTargetCity:GetY(), eBuilding);
			--end);
			---local BuildingEntry2 = g_InstanceManager:GetInstance();
			--BuildingEntry2.Button:LocalizeAndSetText("TXT_KEY_POINTEDSTRIKE");
			--BuildingEntry2.Button:RegisterCallback(Mouse.eLClick, function()
			--	OnSelected(unit, pTargetCity:GetX(), pTargetCity:GetY(), eBuilding);
			--end);
		--end
		
		local BInstance = {};
		ContextPtr:BuildInstanceForControl("BInstance", BInstance, Controls.ItemStack);
		BInstance.Button:LocalizeAndSetText("TXT_KEY_POINTEDSTRIKE");
		BuildingEntry.Button:RegisterCallback(Mouse.eLClick, function()
			print("OnSelected OK!!");
		end);
	end
end

function OnSelected(unit, iX, iY, eBuilding)
	print("OnSelected! start. eBuilding = " .. eBuilding);
	--unit:AttackPointedStrike(iX, iY, eBuilding);
end

function OnClose() 
	--UIManager:DequeuePopup( ContextPtr );
	ContextPtr:SetHide(true);
end
Controls.CloseButton:RegisterCallback( Mouse.eLClick, OnClose );

print("PointedStrikePopup is active");